## ocamlbricks 0.50.1

=== Makefile ===
# This -*- makefile -*- is part of our build system for OCaml projects
# Copyright (C) 2008  Luca Saiu
# Copyright (C) 2008  Jean-Vincent Loddo
# Updated in 2008 by Jonathan Roudiere

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This is the revision of 2008-04-21.


######################################################################
# This make file is general-purpose: the actual project-dependant part
# should be written for each specific project in a 'Makefile.local'
# file.
#
# This contains some (simple) makefile magic which is only supported
# by GNU Make. Don't even try to use other make implementations.
######################################################################


######################################################################
# Implementation of targets. Note that the user is *not* supposed to
# override these, but only to define the project-dependant '-local'
# versions:

# Makefiles (this one as those in other parts) use extensively the bash shell
SHELL=/bin/bash

OCAMLBUILD = $$( $(call OCAMLBUILD_COMMAND_LINE) )

# The main target. Its implementation is entirely project-dependant:
main: ocamlbuild-stuff main-local data libraries programs documentation
	@(echo "Success.")

BUILD_FROM_STUFF = \
	@( echo "Building $(1)..."; \
	shopt -s execfail; set -e; \
	for x in $(2); do \
	  echo "Building \"$$x\"..."; \
	  if $(MAKE) $$x; then \
	    echo "Ok, \"$$x\" was built with success."; \
	  else \
	    echo "FAILED when building \"$$x\"."; \
	    exit -1; \
	  fi; \
	done; \
	echo "Success: $(1) were built.")

# Build only data:
data: ocamlbuild-stuff data-local $(DATA)
	$(call BUILD_FROM_STUFF, data, $(DATA))

# Build only native libraries:
native-libraries: ocamlbuild-stuff native-libraries-local $(NATIVE_LIBRARIES)
	$(call BUILD_FROM_STUFF, native-libraries, $(NATIVE_LIBRARIES))

# Build only bytecode libraries:
byte-libraries: ocamlbuild-stuff byte-libraries-local $(BYTE_LIBRARIES)
	$(call BUILD_FROM_STUFF, byte-libraries, $(BYTE_LIBRARIES))

# Build libraries; bytecode, native, or both:
libraries: libraries-local
	@($(call BUILD_NATIVE_ANDOR_BYTECODE,libraries) ) # Spaces are ok

# Build programs; bytecode, native, or both:
programs: programs-local
	@($(call BUILD_NATIVE_ANDOR_BYTECODE,programs) ) # Spaces are ok

# Build the native and/or bytecode version of $(1). $(1) may be either
# "libraries" or "programs". *Don't* put a space before the argument.
BUILD_NATIVE_ANDOR_BYTECODE = \
	(if [ "$$( $(call NATIVE) )" == 'native' ]; then \
	  echo "Builing native $(1)..."; \
	  if $(MAKE) native-$(1); then \
	    echo "Success: native $(1) were built."; \
	  else \
	    echo "FAILURE: could not build native $(1)."; \
	    exit -1; \
	  fi; \
	else \
	  echo "NOT builing native $(1)..."; \
	fi; \
	if [ "$$( $(call BYTE) )" == 'byte' ]; then \
	  echo "Builing bytecode $(1)..."; \
	  if $(MAKE) byte-$(1); then \
	    echo "Success: bytecode $(1) were built."; \
	  else \
	    echo "FAILURE: could not build bytecode $(1)."; \
	    exit -1; \
	  fi; \
	else \
	  echo "NOT builing bytecode $(1)..."; \
	fi)

# Build only native programs:
native-programs: ocamlbuild-stuff native-programs-local $(NATIVE_PROGRAMS) $(ROOT_NATIVE_PROGRAMS)
	$(call BUILD_FROM_STUFF, native-programs, $(NATIVE_PROGRAMS) $(ROOT_NATIVE_PROGRAMS))

# Build only bytecode programs:
byte-programs: ocamlbuild-stuff byte-programs-local $(BYTE_PROGRAMS) $(ROOT_BYTE_PROGRAMS)
	$(call BUILD_FROM_STUFF, byte-programs, $(BYTE_PROGRAMS) $(ROOT_BYTE_PROGRAMS))

# 'all' is just an alias for 'main':
all: main

# In some projects we may need to build something more than 'main',
# but we do nothing more by default:
world: world-local main
	@(echo 'Success.')

# Generate ocamldoc documentation:
ocamldoc: ocamldoc-local
	@($(call READ_META, name); \
	$(OCAMLBUILD) $$name.docdir/index.html &> /dev/null && \
	rm $$name.docdir && \
	echo 'Success.'; \
	echo 'The documentation has been built with success under _build/')

# Install programs and libraries:
install: install-programs install-libraries install-data install-configuration install-documentation install-local
	@(echo 'Success.')

# The user is free to override this to add custom targets to install into the
# $prefix/share/$name installation directory:
OTHER_DATA_TO_INSTALL =

# The user is free to override this to add custom targets to install into the
# $documentationprefix/$name installation directory:
OTHER_DOCUMENTATION_TO_INSTALL =

# Install the documentation from this package into $prefix/share/$name:
install-documentation: install-documentation-local
	@($(call READ_CONFIG, documentationprefix); \
	$(call READ_META, name); \
	directory=$$documentationprefix/$$name; \
	shopt -s nullglob; \
	if [ -e doc ]; then \
	  documentationifany=`ls -d doc/*`; \
	else \
	  documentationifany=''; \
	fi; \
	if [ "$$documentationifany" == "" ]; then \
	  echo "No documentation to install: ok, no problem..."; \
	else \
	  echo "Installing $$name documentation into $$directory ..."; \
	  echo "Creating $$directory ..."; \
	  if mkdir -p $$directory; then \
	    echo "The directory $$directory was created with success."; \
	  else \
	    echo "Could not create $$directory"; \
	    exit -1; \
	  fi; \
	  echo "Copying $$name documentation to $$directory ..."; \
	  for x in COPYING README $$documentationifany $(OTHER_DOCUMENTATION_TO_INSTALL); do \
	    if cp -af $$x $$directory; then \
	      echo "Installed $$x into $$directory/"; \
	    else \
	      echo "Could not write $$directory/$$x."; \
	      exit -1; \
	    fi; \
	  done; \
	  echo "Documentation installation for $$name was successful."; \
	fi)

# Just a handy alias:
install-doc: install-documentation

# Install the data from this package into $prefix/share/$name:
install-data: main install-data-local
	@($(call READ_CONFIG, prefix); \
	$(call READ_META, name); \
	directory=$$prefix/share/$$name; \
	shopt -s nullglob; \
	if [ -e share ]; then \
	  dataifany=`ls -d share/*`; \
	else \
	  dataifany=''; \
	fi; \
	if [ "$$dataifany" == "" ]; then \
	  echo "No data to install: ok, no problem..."; \
	else \
	  echo "Installing $$name data into $$directory ..."; \
	  echo "Creating $$directory ..."; \
	  if mkdir -p $$directory; then \
	    echo "The directory $$directory was created with success."; \
	  else \
	    echo "Could not create $$directory"; \
	    exit -1; \
	  fi; \
	  echo "Copying $$name data to $$directory ..."; \
	  for x in COPYING README $$dataifany $(OTHER_DATA_TO_INSTALL); do \
	    if cp -af $$x $$directory; then \
	      echo "Installed $$x into $$directory/"; \
	    else \
	      echo "Could not write $$directory/$$x."; \
	      exit -1; \
	    fi; \
	  done; \
	  echo "Data installation for $$name was successful."; \
	fi)

# Install the software configuration files, if any:
install-configuration: install-configuration-local
	@($(call READ_CONFIG, configurationprefix); \
	$(call READ_META, name); \
	if [ -e etc ]; then \
	  echo "Installing configuration files into $$configurationprefix/$$name..."; \
	  mkdir -p $$configurationprefix/$$name; \
	  shopt -s nullglob; \
	  for file in etc/*; do \
	    basename=`basename $$file`; \
	    echo "Installing $$basename into $$configurationprefix/$$name..."; \
	    if ! cp $$file $$configurationprefix/$$name/; then \
	      echo "ERROR: Could not install $$basename into $$configurationprefix/$$name"; \
	      exit -1; \
	    fi; \
	  done; \
	else \
	  echo "We don't have any configuration files to install."; \
	fi)

# Uninstall the software configuration files, if any:
uninstall-configuration: uninstall-configuration-local
	@($(call READ_CONFIG, configurationprefix); \
	if [ -e etc ]; then \
	  echo "Removing configuration files from $$configurationprefix..."; \
	  shopt -s nullglob; \
	  for file in etc/*; do \
	    basename=`basename $$file`; \
	    echo "Uninstalling $$basename from $$configurationprefix..."; \
	    if ! rm -f $$configurationprefix/$$basename; then \
	      echo "ERROR: Could not remove $$basename from $$configurationprefix"; \
	      exit -1; \
	    fi; \
	  done; \
	else \
	  echo "We don't have any configuration files to remove."; \
	fi)

# Remove the data of this package from $prefix/share/$name:
uninstall-data: uninstall-data-local
	@( ($(call READ_CONFIG, prefix); \
	$(call READ_META, name); \
	directory=$$prefix/share/$$name; \
	echo "Removing $$name data from $$prefix/share/..."; \
	shopt -s nullglob; \
	if rm -rf $$directory; then \
	  echo "The entire directory $$directory was removed."; \
	else \
	  echo "Could not delete $$directory"; \
	  exit -1; \
	fi); \
	echo 'Data uninstallation was successful.')

# Remove the documentation of this package from $documentationprefix/$name:
uninstall-documentation: documentation uninstall-documentation-local
	@( ($(call READ_CONFIG, documentationprefix); \
	$(call READ_META, name); \
	directory=$$documentationprefix/$$name; \
	echo "Removing $$name documentation from $$documentationprefix..."; \
	shopt -s nullglob; \
	if rm -rf $$directory; then \
	  echo "The entire directory $$directory was removed."; \
	else \
	  echo "Could not delete $$directory"; \
	  exit -1; \
	fi); \
	echo 'Documentation uninstallation was successful.')

# Create the documentation (do nothing by default):
documentation: documentation-local
	@(echo 'Success: documentation was build.')

# Just a handy alias:
doc: documentation

# The user is free to override this to add custom targets to install into the
# $prefix/bin installation directory; the typical use of this would be
# installing scripts.
OTHER_PROGRAMS_TO_INSTALL =

# These are programs to be installed into $prefix/sbin instead of $prefix/bin:
ROOT_NATIVE_PROGRAMS =
ROOT_BYTE_PROGRAMS =

# Install the programs from this package into $prefix/bin:
install-programs: programs install-programs-local
	@($(call READ_CONFIG, prefix); 		     \
	$(call READ_META, name);   		     \
	echo "Creating $$prefix/bin/..."; \
	(mkdir -p $$prefix/bin &> /dev/null || true); \
	echo "Creating $$prefix/sbin/..."; \
	(mkdir -p $$prefix/sbin &> /dev/null || true); \
	echo "Installing programs from $$name into $$prefix/bin/..."; \
	shopt -s nullglob; \
	for file in $(OTHER_PROGRAMS_TO_INSTALL) _build/*.byte _build/*.native; do \
	  basename=`basename $$file`; \
	  if echo " $(ROOT_NATIVE_PROGRAMS) $(ROOT_BYTE_PROGRAMS) " | grep -q " $$basename "; then \
	    echo "Installing "`basename $$file`" as a \"root program\" into $$prefix/sbin..."; \
	    cp -a $$file $$prefix/sbin/; \
	  else \
	    echo "Installing "`basename $$file`" into $$prefix/bin..."; \
	    cp -a $$file $$prefix/bin/; \
	  fi; \
	done) && \
	echo 'Program installation was successful.'

# Remove the programs from this package from $prefix/bin:
uninstall-programs: main uninstall-programs-local
	@($(call READ_CONFIG, prefix); 		     \
	$(call READ_META, name);   		     \
	echo "Removing $$name programs..."; \
	shopt -s nullglob; \
	for file in $(OTHER_PROGRAMS_TO_INSTALL) _build/*.byte _build/*.native; do \
	  basename=`basename $$file`; \
	  if echo " $(ROOT_NATIVE_PROGRAMS) $(ROOT_BYTE_PROGRAMS) " | grep -q " $$basename "; then \
	    echo -e "Removing the \"root program\" $$basename from $$prefix/sbin..."; \
	    export pathname=$$prefix/sbin/`basename $$file`; \
	  else \
	    echo -e "Removing $$basename from $$prefix/bin..."; \
	    export pathname=$$prefix/bin/`basename $$file`; \
	  fi; \
	  rm -f $$pathname; \

## ocamlbricks 0.90%2Bbzr400

=== debian/control ===
Source: ocamlbricks
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Lucas Nussbaum <lucas@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends: debhelper (>= 8),
 ocaml-nox (>= 3.12.1),
 liblablgtk2-ocaml-dev (>= 2.12.0-2),
 bash (>= 3.1),
 dh-ocaml (>= 0.9.1),
 ocaml-findlib,
 bzr,
 camlp4-extra
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocamlbricks.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocamlbricks.git
Homepage: https://launchpad.net/ocamlbricks

Package: libocamlbricks-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}, liblablgtk2-ocaml-dev (>= 2.12.0-2)
Provides: ${ocaml:Provides}
Replaces: ocamlbricks (<< 0.50.1)
Suggests: ocaml-findlib
Description: Miscellaneous utility functions in OCaml for Marionnet
 This OCaml library provides a set of needed and useful macros for developing.
 It is mainly used by the marionnet package.
 Modules and functionality are the following :
 .
  - Configuration_files: Allow to get information from configuration files
  - Environments: Environments are useful for maintaining the state, intendend 
 as a set of bindings, of a user interaction with a GUI
  - FilenameExtra: Additional features for the standard module Filename
  - Fix: Poor man fix point operators
  - Hashm[m]ap: 2 Module implementing polymorphic unbounded (multi) maps
  - Hashset: Very simple module implementing a polymorphic unbounded sets
  - Identifier: Build and manage unique (fresh) identifiers
  - Ledgrid: Constants Some global constant definitions, for fine-tuning
  - ListExtra: Additional features for the standard module List
  - Memo: Module for building memoised functions
  - Oomarshal: Object-oriented marshalling support
  - PreludeExtra: "Additional features" for the standard module Pervasives
  - Shell: A collection of (mainly quick and easy) wrappers for the most 
 famous Unix tools and generic unix commands or scripts
  - StrExtra: Additional features for the standard library Str
  - Sugar: Basic shortcuts and syntactic sugar
  - SysExtra: Additional features for the standard module Sys
  - UnixExtra: Additional features for the standard library Unix
  - Widget: Some generic tools for building GUIs
  - Wrapper: Handling shell scripts in OCaml

## ocamlbricks 0.90+bzr367

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 # This -*- makefile -*- is part of our build system for OCaml projects
-# Copyright (C) 2008  Luca Saiu
-# Copyright (C) 2008  Jean-Vincent Loddo
+# Copyright (C) 2008, 2009  Luca Saiu
+# Copyright (C) 2008, 2010  Jean-Vincent Loddo
+# Copyright (C) 2008, 2009, 2010  Université Paris 13
 # Updated in 2008 by Jonathan Roudiere
 
 # This program is free software: you can redistribute it and/or modify
@@ -38,10 +39,19 @@
 SHELL=/bin/bash
 
 OCAMLBUILD = $$( $(call OCAMLBUILD_COMMAND_LINE) )
+LIBRARYPREFIX=$(shell $(call READ_CONFIG, libraryprefix); echo $$libraryprefix)
+OCAML_LIBRARYPREFIX=$(shell $(call READ_CONFIG, ocaml_libraryprefix); echo $$ocaml_libraryprefix)
 
 # The main target. Its implementation is entirely project-dependant:
-main: ocamlbuild-stuff main-local data libraries programs documentation
+main: ocamlbuild-stuff manually_pre_actions main-local data libraries programs manually_post_actions
 	@(echo "Success.")
+
+# Build C modules (no one, by default):
+c-modules:
+	@(mkdir _build &> /dev/null || true) && \
+	for x in $(C_OBJECTS_TO_LINK); do \
+	  make _build/$$x.o; \
+	done
 
 BUILD_FROM_STUFF = \
 	@( echo "Building $(1)..."; \
@@ -62,20 +72,22 @@
 	$(call BUILD_FROM_STUFF, data, $(DATA))
 
 # Build only native libraries:
-native-libraries: ocamlbuild-stuff native-libraries-local $(NATIVE_LIBRARIES)
+native-libraries: ocamlbuild-stuff c-modules native-libraries-local $(NATIVE_LIBRARIES)
 	$(call BUILD_FROM_STUFF, native-libraries, $(NATIVE_LIBRARIES))
 
 # Build only bytecode libraries:
-byte-libraries: ocamlbuild-stuff byte-libraries-local $(BYTE_LIBRARIES)
+byte-libraries: ocamlbuild-stuff c-modules byte-libraries-local $(BYTE_LIBRARIES)
 	$(call BUILD_FROM_STUFF, byte-libraries, $(BYTE_LIBRARIES))
 
 # Build libraries; bytecode, native, or both:
-libraries: libraries-local
+libraries: c-modules libraries-local
 	@($(call BUILD_NATIVE_ANDOR_BYTECODE,libraries) ) # Spaces are ok
 
 # Build programs; bytecode, native, or both:
-programs: programs-local
+# Force the meta.ml regeneration at next make call
+programs: c-modules programs-local
 	@($(call BUILD_NATIVE_ANDOR_BYTECODE,programs) ) # Spaces are ok
+	touch META
 
 # Build the native and/or bytecode version of $(1). $(1) may be either
 # "libraries" or "programs". *Don't* put a space before the argument.
@@ -119,13 +131,97 @@
 world: world-local main
 	@(echo 'Success.')
 
-# Generate ocamldoc documentation:
-ocamldoc: ocamldoc-local
-	@($(call READ_META, name); \
-	$(OCAMLBUILD) $$name.docdir/index.html &> /dev/null && \
-	rm $$name.docdir && \
-	echo 'Success.'; \
-	echo 'The documentation has been built with success under _build/')
+
+############################################################################
+# Support for manually generated files (i.e. not generated with ocamlbuild)
+############################################################################
+
+# Example: (in your Makefile.local)
+#
+# foo.byte   : manually_pre_actions
+# foo.native : manually_pre_actions
+#
+# MANUALLY_PRE_COPY_IN_build = include_as_string_p4.ml USAGE.txt
+# MANUALLY_PRE_MAKE_IN_build = include_as_string_p4.cmo
+#
+# _build/include_as_string_p4.cmo: include_as_string_p4.ml
+#	ocamlc -c -I +camlp4 camlp4lib.cma -pp camlp4of -o $@ $<
+
+.PHONY : manually_pre_actions manually_post_actions
+
+################################# PRE-ACTIONS support
+
+# Files that must be copied in _build/ *before* the ocamlbuild processing.
+MANUALLY_PRE_COPY_IN_build =
+
+# Targets that must be created in _build/ *before* the ocamlbuild processing.
+# For each foo.bar that appears in this list, you have to write a rule
+# _build/foo.bar in your Makefile.local
+MANUALLY_PRE_MAKE_IN_build =
+
+manually_pre_actions:
+	$(call PERFORM_MANUALLY_PRE_ACTIONS, $(MANUALLY_PRE_COPY_IN_build),$(MANUALLY_PRE_MAKE_IN_build))
+
+# Detect if "make clean" is required or copy and build manually targets
+# specified in MANUALLY_PRE_COPY_IN_build and MANUALLY_PRE_MAKE_IN_build
+PERFORM_MANUALLY_PRE_ACTIONS = \
+	@(\
+	if test -d _build/; \
+	then \
+	  echo "Checking if files manually copied in _build/ have been modified..."; \
+	  for x in $(1); do \
+	    echo "Checking \"$$x\"..."; \
+	    test ! -f _build/$$x || \
+	       diff -q $$x _build/$$x 2>/dev/null || \
+	       { echo -e "********************\nmake clean required!\n********************"; exit 1; } ;\
+	  done; \
+	else \
+	  mkdir _build/; \
+	fi; \
+	for x in $(1); do echo "Manually pre-copying \"$$x\"...";  cp --parent -f $$x _build/; done; \
+	for y in $(2); do echo "Manually pre-building \"$$y\"..."; make _build/$$y || exit 1; done; \
+	)
+
+################################# POST-ACTIONS support
+
+# Files that must be copied in _build/ *after* the ocamlbuild processing.
+MANUALLY_POST_COPY_IN_build =
+
+# Targets that must be created in _build/ *after* the ocamlbuild processing.
+# For each foo.bar that appears in this list, you have to write a rule
+# _build/foo.bar in your Makefile.local
+MANUALLY_POST_MAKE_IN_build =
+
+manually_post_actions:
+	$(call PERFORM_MANUALLY_POST_ACTIONS, $(MANUALLY_POST_COPY_IN_build), $(MANUALLY_POST_MAKE_IN_build))
+
+PERFORM_MANUALLY_POST_ACTIONS = \
+	@(\
+	for x in $(1); do echo "Manually post-copying \"$$x\"...";  cp --parent -f $$x _build/; done; \
+	for y in $(2); do echo "Manually post-building \"$$y\"..."; make _build/$$y || exit 1; done; \
+	)
+
+
+
+############################################################################
+# Other entries
+
+
+# Edit all ml/mli files and Makefile.local with your $EDITOR
+edit:
+	test -n "$$EDITOR" && $$EDITOR Makefile.local $$(find . \( -wholename "./_build/*" -o -name "meta.ml" -o -name "$(EXCLUDE_FROM_EDITING)" -o -name "version.ml" -o -name "gui.ml" -o -name myocamlbuild.ml \) -prune -o -type f -a \( -name "*.ml" -o -name "*.mli" \) -print) &
+
+# Create the documentation
+documentation: world documentation-local
+	chmod +x Makefile.d/doc.sh
+	Makefile.d/doc.sh -pp "$(PP_OPTION)" -e "$(UNDOCUMENTED)" -i $(DIRECTORIES_TO_INCLUDE)
+
+doc: documentation
+
+INDEX_HTML=_build/doc/html/index.html
+browse:
+	test -f  $(INDEX_HTML) || make documentation
+	test -n "$$BROWSER" && $$BROWSER $(INDEX_HTML)
 
 # Install programs and libraries:
 install: install-programs install-libraries install-data install-configuration install-documentation install-local
@@ -139,14 +235,14 @@
 # $documentationprefix/$name installation directory:
 OTHER_DOCUMENTATION_TO_INSTALL =
 
-# Install the documentation from this package into $prefix/share/$name:
+# Install the documentation from this package (_build/doc) into $prefix/share/$name:
 install-documentation: install-documentation-local
 	@($(call READ_CONFIG, documentationprefix); \
 	$(call READ_META, name); \
 	directory=$$documentationprefix/$$name; \
 	shopt -s nullglob; \
-	if [ -e doc ]; then \
-	  documentationifany=`ls -d doc/*`; \
+	if [ -e _build/doc ]; then \
+	  documentationifany=`ls -d _build/doc/*`; \
 	else \
 	  documentationifany=''; \
 	fi; \
@@ -233,102 +329,3 @@
 # Uninstall the software configuration files, if any:
 uninstall-configuration: uninstall-configuration-local
 	@($(call READ_CONFIG, configurationprefix); \
-	if [ -e etc ]; then \
-	  echo "Removing configuration files from $$configurationprefix..."; \
-	  shopt -s nullglob; \
-	  for file in etc/*; do \
-	    basename=`basename $$file`; \
-	    echo "Uninstalling $$basename from $$configurationprefix..."; \
-	    if ! rm -f $$configurationprefix/$$basename; then \
-	      echo "ERROR: Could not remove $$basename from $$configurationprefix"; \
-	      exit -1; \
-	    fi; \
-	  done; \
-	else \
-	  echo "We don't have any configuration files to remove."; \
-	fi)
-
-# Remove the data of this package from $prefix/share/$name:
-uninstall-data: uninstall-data-local
-	@( ($(call READ_CONFIG, prefix); \
-	$(call READ_META, name); \
-	directory=$$prefix/share/$$name; \
-	echo "Removing $$name data from $$prefix/share/..."; \
-	shopt -s nullglob; \
-	if rm -rf $$directory; then \
-	  echo "The entire directory $$directory was removed."; \
-	else \
-	  echo "Could not delete $$directory"; \
-	  exit -1; \
-	fi); \
-	echo 'Data uninstallation was successful.')
-
-# Remove the documentation of this package from $documentationprefix/$name:
-uninstall-documentation: documentation uninstall-documentation-local
-	@( ($(call READ_CONFIG, documentationprefix); \
-	$(call READ_META, name); \
-	directory=$$documentationprefix/$$name; \
-	echo "Removing $$name documentation from $$documentationprefix..."; \
-	shopt -s nullglob; \
-	if rm -rf $$directory; then \
-	  echo "The entire directory $$directory was removed."; \
-	else \
-	  echo "Could not delete $$directory"; \
-	  exit -1; \
-	fi); \
-	echo 'Documentation uninstallation was successful.')
-
-# Create the documentation (do nothing by default):
-documentation: documentation-local
-	@(echo 'Success: documentation was build.')
-
-# Just a handy alias:
-doc: documentation
-
-# The user is free to override this to add custom targets to install into the
-# $prefix/bin installation directory; the typical use of this would be
-# installing scripts.
-OTHER_PROGRAMS_TO_INSTALL =
-
-# These are programs to be installed into $prefix/sbin instead of $prefix/bin:
-ROOT_NATIVE_PROGRAMS =
-ROOT_BYTE_PROGRAMS =
-
-# Install the programs from this package into $prefix/bin:
-install-programs: programs install-programs-local
-	@($(call READ_CONFIG, prefix); 		     \
-	$(call READ_META, name);   		     \
-	echo "Creating $$prefix/bin/..."; \
-	(mkdir -p $$prefix/bin &> /dev/null || true); \
-	echo "Creating $$prefix/sbin/..."; \
-	(mkdir -p $$prefix/sbin &> /dev/null || true); \
-	echo "Installing programs from $$name into $$prefix/bin/..."; \
-	shopt -s nullglob; \
-	for file in $(OTHER_PROGRAMS_TO_INSTALL) _build/*.byte _build/*.native; do \
-	  basename=`basename $$file`; \
-	  if echo " $(ROOT_NATIVE_PROGRAMS) $(ROOT_BYTE_PROGRAMS) " | grep -q " $$basename "; then \
-	    echo "Installing "`basename $$file`" as a \"root program\" into $$prefix/sbin..."; \
-	    cp -a $$file $$prefix/sbin/; \
-	  else \
-	    echo "Installing "`basename $$file`" into $$prefix/bin..."; \
-	    cp -a $$file $$prefix/bin/; \
-	  fi; \
-	done) && \
-	echo 'Program installation was successful.'
-
-# Remove the programs from this package from $prefix/bin:
-uninstall-programs: main uninstall-programs-local
-	@($(call READ_CONFIG, prefix); 		     \
-	$(call READ_META, name);   		     \
-	echo "Removing $$name programs..."; \
-	shopt -s nullglob; \
-	for file in $(OTHER_PROGRAMS_TO_INSTALL) _build/*.byte _build/*.native; do \
-	  basename=`basename $$file`; \
-	  if echo " $(ROOT_NATIVE_PROGRAMS) $(ROOT_BYTE_PROGRAMS) " | grep -q " $$basename "; then \
-	    echo -e "Removing the \"root program\" $$basename from $$prefix/sbin..."; \
-	    export pathname=$$prefix/sbin/`basename $$file`; \
-	  else \
-	    echo -e "Removing $$basename from $$prefix/bin..."; \
-	    export pathname=$$prefix/bin/`basename $$file`; \
-	  fi; \
-	  rm -f $$pathname; \

=== debian/changelog ===
ocamlbricks (0.90+bzr367-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- Lucas Nussbaum <lucas@debian.org>  Wed, 10 Jul 2013 10:46:00 +0200

ocamlbricks (0.90+bzr367-1) unstable; urgency=low

  * New upstream snapshot.

 -- Lucas Nussbaum <lucas@debian.org>  Fri, 05 Jul 2013 16:29:21 +0200

ocamlbricks (0.90+bzr365-1) unstable; urgency=low

  * New upstream snapshot from the trunk branch
  * Add myself to Uploaders
  * Update Uploaders to reflect the current state of the package. Thanks,
    Jonathan!
  * Update to Standards-Version 3.9.4 (no changes)
  * Use canonical Git URIs
  * Remove empty directories
  * Add DEP-3 headers for patches

 -- Nicolas Dandrimont <nicolas.dandrimont@crans.org>  Sun, 23 Jun 2013 15:30:45 +0200

ocamlbricks (0.90+bzr364.3-1) unstable; urgency=low

  * New upstream snapshot. Should fix the build failures on
    non-native ocaml architectures.
  * Add no-ocamlopt-arches.diff: work-around for partial upstream fix
    (see https://bugs.launchpad.net/ocamlbricks/+bug/1130098).

 -- Lucas Nussbaum <lucas@debian.org>  Tue, 28 May 2013 16:38:50 +0200

ocamlbricks (0.90+bzr356-1) unstable; urgency=low

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders

  [ Lucas Nussbaum ]
  * New upstream snapshot from the trunk branch, after discussion with
    upstream author in https://bugs.launchpad.net/marionnet/+bug/1085055.
    This is a step towards packaging marionnet.
  * Rework most of the packaging.
  * Update Standards-Version. No changes needed.
  * New homepage: https://launchpad.net/ocamlbricks

 -- Lucas Nussbaum <lucas@debian.org>  Mon, 18 Feb 2013 21:08:04 +0100

ocamlbricks (0.50.1-4) unstable; urgency=low

  [ Mehdi Dogguy ]
  * Add a .doc-base file for the documentation instead of calling by
    hand ocamldoc-api-ref-config (Closes: #549732).

  [ Sylvain Le Gall ]
  * Use dh_ocaml 0.9 features: OCaml:Provides and OCaml:Depends
  * Downgrade build-depends from ocaml to ocaml-nox
  * Upgrade Standards-Version to 3.8.3 (section ocaml)
  * Add debian/README.source
  * Use ocamlinit.mk (Closes: #521429)

 -- Sylvain Le Gall <gildor@debian.org>  Wed, 07 Oct 2009 09:03:49 +0000

ocamlbricks (0.50.1-3) unstable; urgency=low
  
  [ Jonathan Roudiere ]
  * Change the maintainer of ocamlbricks to Debian OCaml Maintainers
  * Fix bug and compatibility with dash, change 'source' by '.' in
    CONFIGURATION/configuration_files.m and invoke bash explicitly
    in unixExtra.ml
  * miror changes in debian/{rules,control}, update version of
    Debian Policy
  * Solve META lacks dependencies (Closes: #521428)

  [ Sylvain Le Gall ]
  * Add debian/gbp.conf to force using pristine-tar
  * Change debian revision, to match latest uploaded version

  [ Stephane Glondu ]
  * Add dh-ocaml to Build-Depends, update call to ocamldoc-api-ref-config
    (Closes: #519632)
  * Update versions in Build-Depends for OCaml 3.11.0 transition

 -- Sylvain Le Gall <gildor@debian.org>  Sun, 29 Mar 2009 20:13:43 +0200

ocamlbricks (0.50.1-1) unstable; urgency=low

  [ Jonathan Roudiere ]
  * Initial release (closes: Bug#477326) 
    First package of OCamlbricks, including documentation OCamldoc in HTML
    format and the build system use to build OCamlbricks like an example.

  * Creation and adding *.mli (OCaml header files) in the package.

  [ Sylvain Le Gall ]
  * Final fix, review and upload 

 -- Sylvain Le Gall <gildor@debian.org>  Tue, 17 Jun 2008 01:04:30 +0200

## ocamlbricks 0.90+bzr400

=== Makefile ===
--- 
+++ 
@@ -84,16 +84,14 @@
 	@($(call BUILD_NATIVE_ANDOR_BYTECODE,libraries) ) # Spaces are ok
 
 # Build programs; bytecode, native, or both:
-# Force the meta.ml regeneration at next make call
 programs: c-modules programs-local
 	@($(call BUILD_NATIVE_ANDOR_BYTECODE,programs) ) # Spaces are ok
-	touch META
 
 # Build the native and/or bytecode version of $(1). $(1) may be either
 # "libraries" or "programs". *Don't* put a space before the argument.
 BUILD_NATIVE_ANDOR_BYTECODE = \
 	(if [ "$$( $(call NATIVE) )" == 'native' ]; then \
-	  echo "Builing native $(1)..."; \
+	  echo "Building native $(1)..."; \
 	  if $(MAKE) native-$(1); then \
 	    echo "Success: native $(1) were built."; \
 	  else \
@@ -101,7 +99,7 @@
 	    exit -1; \
 	  fi; \
 	else \
-	  echo "NOT builing native $(1)..."; \
+	  echo "NOT building native $(1)..."; \
 	fi; \
 	if [ "$$( $(call BYTE) )" == 'byte' ]; then \
 	  echo "Builing bytecode $(1)..."; \
@@ -112,7 +110,7 @@
 	    exit -1; \
 	  fi; \
 	else \
-	  echo "NOT builing bytecode $(1)..."; \
+	  echo "NOT building bytecode $(1)..."; \
 	fi)
 
 # Build only native programs:
@@ -209,8 +207,7 @@
 
 # Edit all ml/mli files and Makefile.local with your $EDITOR
 edit:
-	test -n "$$EDITOR" && $$EDITOR Makefile.local $$(find . \( -wholename "./_build/*" -o -name "meta.ml" -o -name "$(EXCLUDE_FROM_EDITING)" -o -name "version.ml" -o -name "gui.ml" -o -name myocamlbuild.ml \) -prune -o -type f -a \( -name "*.ml" -o -name "*.mli" \) -print) &
-
+	test -n "$$EDITOR" && eval $$EDITOR Makefile.local $$(find . \( -name "_build*" -o -name "meta.ml" -o -name "$(EXCLUDE_FROM_EDITING)" -o -name "version.ml" -o -name "gui.ml" -o -name myocamlbuild.ml \) -prune -o -type f -a \( -name "*.ml" -o -name "*.mli" \) -print) &
 # Create the documentation
 documentation: world documentation-local
 	chmod +x Makefile.d/doc.sh
@@ -236,7 +233,7 @@
 OTHER_DOCUMENTATION_TO_INSTALL =
 
 # Install the documentation from this package (_build/doc) into $prefix/share/$name:
-install-documentation: install-documentation-local
+install-documentation: META CONFIGME install-documentation-local
 	@($(call READ_CONFIG, documentationprefix); \
 	$(call READ_META, name); \
 	directory=$$documentationprefix/$$name; \
@@ -273,7 +270,7 @@
 install-doc: install-documentation
 
 # Install the data from this package into $prefix/share/$name:
-install-data: main install-data-local
+install-data: META CONFIGME main install-data-local
 	@($(call READ_CONFIG, prefix); \
 	$(call READ_META, name); \
 	directory=$$prefix/share/$$name; \
@@ -307,7 +304,7 @@
 	fi)
 
 # Install the software configuration files, if any:
-install-configuration: install-configuration-local
+install-configuration: META CONFIGME install-configuration-local
 	@($(call READ_CONFIG, configurationprefix); \
 	$(call READ_META, name); \
 	if [ -e etc ]; then \
@@ -327,5 +324,6 @@
 	fi)
 
 # Uninstall the software configuration files, if any:
-uninstall-configuration: uninstall-configuration-local
+uninstall-configuration: CONFIGME uninstall-configuration-local
 	@($(call READ_CONFIG, configurationprefix); \
+	if [ -e etc ]; then \

=== debian/changelog ===
ocamlbricks (0.90+bzr400-2) unstable; urgency=medium

  * Team upload
  * Fix a call to Obj.magic that caused segfaults (Closes: #860405)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Apr 2017 13:15:07 +0200

ocamlbricks (0.90+bzr400-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Lucas Nussbaum <lucas@debian.org>  Tue, 08 Jul 2014 11:09:39 +0200

ocamlbricks (0.90+bzr393-1) unstable; urgency=medium

  * New upstream snapshot.
  * Refreshed patches, due to buildsystem changes.
    + Add patch 0004-install-stublibs.patch

 -- Lucas Nussbaum <lucas@debian.org>  Wed, 02 Apr 2014 19:19:00 +0200

## ocamlbricks 0.90+bzr456

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,10 @@
 # This -*- makefile -*- is part of our build system for OCaml projects
 # Copyright (C) 2008, 2009  Luca Saiu
-# Copyright (C) 2008, 2010  Jean-Vincent Loddo
-# Copyright (C) 2008, 2009, 2010  Université Paris 13
+# Copyright (C) 2008, 2010, 2016  Jean-Vincent Loddo
+# Copyright (C) 2008, 2009, 2010, 2016  Université Paris 13
 # Updated in 2008 by Jonathan Roudiere
+# Thanks to JulioJu (https://github.com/JulioJu) for the patch
+# about prefix_install
 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,8 +19,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-# This is the revision of 2008-04-21.
-
+# This is the revision of 2016-06-07.
 
 ######################################################################
 # This make file is general-purpose: the actual project-dependant part
@@ -40,6 +41,7 @@
 
 OCAMLBUILD = $$( $(call OCAMLBUILD_COMMAND_LINE) )
 LIBRARYPREFIX=$(shell $(call READ_CONFIG, libraryprefix); echo $$libraryprefix)
+OCAML_VERSION=$(shell $(call READ_CONFIG, ocaml_version); echo $$ocaml_version)
 OCAML_LIBRARYPREFIX=$(shell $(call READ_CONFIG, ocaml_libraryprefix); echo $$ocaml_libraryprefix)
 
 # The main target. Its implementation is entirely project-dependant:
@@ -225,14 +227,14 @@
 	@(echo 'Success.')
 
 # The user is free to override this to add custom targets to install into the
-# $prefix/share/$name installation directory:
+# $prefix_install/share/$name installation directory:
 OTHER_DATA_TO_INSTALL =
 
 # The user is free to override this to add custom targets to install into the
 # $documentationprefix/$name installation directory:
 OTHER_DOCUMENTATION_TO_INSTALL =
 
-# Install the documentation from this package (_build/doc) into $prefix/share/$name:
+# Install the documentation from this package (_build/doc) into $prefix_install/share/$name:
 install-documentation: META CONFIGME install-documentation-local
 	@($(call READ_CONFIG, documentationprefix); \
 	$(call READ_META, name); \
@@ -269,11 +271,11 @@
 # Just a handy alias:
 install-doc: install-documentation
 
-# Install the data from this package into $prefix/share/$name:
+# Install the data from this package into $prefix_install/share/$name:
 install-data: META CONFIGME main install-data-local
-	@($(call READ_CONFIG, prefix); \
+	@($(call READ_CONFIG, prefix_install); \
 	$(call READ_META, name); \
-	directory=$$prefix/share/$$name; \
+	directory=$$prefix_install/share/$$name; \
 	shopt -s nullglob; \
 	if [ -e share ]; then \
 	  dataifany=`ls -d share/*`; \
@@ -320,10 +322,3 @@
 	    fi; \
 	  done; \
 	else \
-	  echo "We don't have any configuration files to install."; \
-	fi)
-
-# Uninstall the software configuration files, if any:
-uninstall-configuration: CONFIGME uninstall-configuration-local
-	@($(call READ_CONFIG, configurationprefix); \
-	if [ -e etc ]; then \

=== debian/changelog ===
ocamlbricks (0.90+bzr456-2build1) focal; urgency=medium

  * No-change rebuild against ocaml-nox-4.08.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2020 07:32:26 +0000

ocamlbricks (0.90+bzr456-2) unstable; urgency=medium

  * Team upload
  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

 -- Stéphane Glondu <glondu@debian.org>  Sat, 07 Sep 2019 11:07:40 +0200

ocamlbricks (0.90+bzr456-1) unstable; urgency=medium

  * Refresh patches.
  * Add ocamlbuild to build-depends
  * Run wrap-and-sort -a
  * New upstream version 0.90+bzr456
  * Add breaks on older marionnet
  * Bump debian/compat to 9
  * Bump Standards-version to 4.1.1. No changes needed.
  * Fix FTBFS. Closes: #876734

 -- Lucas Nussbaum <lucas@debian.org>  Mon, 30 Oct 2017 23:05:33 +0100

=== debian/control ===
Source: ocamlbricks
Section: ocaml
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Lucas Nussbaum <lucas@debian.org>
Build-Depends: bash (>= 3.1),
               bzr,
               camlp4-extra,
               debhelper (>= 9),
               dh-ocaml (>= 0.9.1),
               liblablgtk2-ocaml-dev (>= 2.12.0-2),
               ocaml-findlib,
               ocaml-nox (>= 3.12.1),
               ocamlbuild
Standards-Version: 4.1.1
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocamlbricks
Vcs-Git: https://salsa.debian.org/ocaml-team/ocamlbricks.git
Homepage: https://launchpad.net/ocamlbricks

Package: libocamlbricks-ocaml-dev
Architecture: any
Depends: liblablgtk2-ocaml-dev (>= 2.12.0-2),
         ${misc:Depends},
         ${ocaml:Depends},
         ${shlibs:Depends}
Provides: ${ocaml:Provides}
Replaces: ocamlbricks (<< 0.50.1)
Breaks: marionnet (<< 0.90.6+bzr506)
Suggests: ocaml-findlib
Description: Miscellaneous utility functions in OCaml for Marionnet
 This OCaml library provides a set of needed and useful macros for developing.
 It is mainly used by the marionnet package.
 Modules and functionality are the following :
 .
  - Configuration_files: Allow to get information from configuration files
  - Environments: Environments are useful for maintaining the state, intendend
 as a set of bindings, of a user interaction with a GUI
  - FilenameExtra: Additional features for the standard module Filename
  - Fix: Poor man fix point operators
  - Hashm[m]ap: 2 Module implementing polymorphic unbounded (multi) maps
  - Hashset: Very simple module implementing a polymorphic unbounded sets
  - Identifier: Build and manage unique (fresh) identifiers
  - Ledgrid: Constants Some global constant definitions, for fine-tuning
  - ListExtra: Additional features for the standard module List
  - Memo: Module for building memoised functions
  - Oomarshal: Object-oriented marshalling support
  - PreludeExtra: "Additional features" for the standard module Pervasives
  - Shell: A collection of (mainly quick and easy) wrappers for the most
 famous Unix tools and generic unix commands or scripts
  - StrExtra: Additional features for the standard library Str
  - Sugar: Basic shortcuts and syntactic sugar
  - SysExtra: Additional features for the standard module Sys
  - UnixExtra: Additional features for the standard library Unix
  - Widget: Some generic tools for building GUIs
  - Wrapper: Handling shell scripts in OCaml

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_build:
	# workaround for https://bugs.launchpad.net/ocamlbricks/+bug/1173148
	make meta.ml ; make meta.ml.released
	dh_auto_build

override_dh_auto_clean:
	dh_auto_clean
	rm -f meta_ocamlbricks.ml

override_dh_auto_install:
	dh_auto_install
	rm -r $(CURDIR)/debian/libocamlbricks-ocaml-dev/bin
	rm -r $(CURDIR)/debian/libocamlbricks-ocaml-dev/sbin

override_dh_auto_test:
	# do nothing

# see https://launchpad.net/ocamlbricks/trunk
PACKAGE = ocamlbricks
SRC_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')
BZR_REVISION := $(shell echo $(SRC_VERSION) | awk -F"+" '{ print $$2 }' | sed 's/bzr//' )
TARBALL = $(PACKAGE)_$(SRC_VERSION).orig.tar.gz
get-orig-source:
	rm -rf get-orig-source $(TARBALL)
	mkdir get-orig-source
	bzr branch -r $(BZR_REVISION) lp:$(PACKAGE)/trunk get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig
	make -C get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig meta.ml.released
	rm get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig/meta.ml
	rm -rf get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig/.bzr
	GZIP=--best tar czf $(TARBALL) -C get-orig-source $(PACKAGE)-$(SRC_VERSION).orig
	rm -rf get-orig-source
	echo "  "$(TARBALL)" created; move it to the right destination to build the package"

.PHONY: get-orig-source
